; --------------------------------------------------------------
; This program reads and displays its command line, then waits
; for a key press before terminating.
;
; The program loader sets ES and DS to the segment address of
; the PSP. The startup directive sets DS (and SS) to DGROUP,
; but leaves ES set to the PSP. The byte at offset 80h in the
; PSP contains the length of the command line including the
; leading space but not including the terminating CR (CR =
; carriage return, ASCII code 0dh). This code ignores the
; length byte and scans for the CR.
; --------------------------------------------------------------
    .model small
    .386
    .stack
.data
.code
.startup
    mov   bx, 81h
  @@:
    mov   dl, es:[bx]
    inc   bx
    mov   ah, 2   ; DOS Display Character function
    int   21h
    cmp   dl, 0dh
    jne   @B
    mov   ah, 2
    mov   dl, 0ah ; Display linefeed to move cursor to next line
    int   21h
    mov   ah, 0   ; BIOS Get Keystroke function
    int   16h     ; BIOS will wait for key press
.exit
end
